<'
# Copyright (c) 2012 LAAS/CNRS
# All rights reserved.
#
# Redistribution and use  in source  and binary  forms,  with or without
# modification, are permitted provided that the following conditions are
# met:
#
#   1. Redistributions of  source  code must retain the  above copyright
#      notice and this list of conditions.
#   2. Redistributions in binary form must reproduce the above copyright
#      notice and  this list of  conditions in the  documentation and/or
#      other materials provided with the distribution.
#
#                                      Anthony Mallet on Mon Sep 17 2012
#

if {[llength $argv] != 1} { error "expected arguments: component" }
lassign $argv component

# compute handy shortcuts
set comp [$component name]
set COMP [string toupper [$component name]]

lang c
'>
#ifndef H_<"$COMP">_MSGLIB
#define H_<"$COMP">_MSGLIB

#include "actionlib/client/action_client.h"

#include "<"$comp">_service.h"
#include "<"$comp">_action.h"

<'foreach s [$component services] {'>
<'  if {[catch {$s task}]} {'>
<'  } else {'>
typedef actionlib::ActionClient< genom::action::<"[$s name]"> >
	gnmix_<"[$s name]">;
<'  }'>
<'}'>

struct connections {
<'foreach s [$component services] {'>
<'  if {[catch {$s task}]} {'>
  ros::ServiceClient <"[$s name]">;
<'  } else {'>
  gnmix_<"[$s name]"> *<"[$s name]">;
  std::list< gnmix_<"[$s name]">::GoalHandle > <"[$s name]">_gh;
<'  }'>
<'}'>
};


#endif /* H_<"$COMP">_MSGLIB */
